var EasyCopyKeyManager = {
	/**
	 * Returns an array of <code>key</code>s based on the templates provided.
	 */
	buildKeys : function(templates) {
		var keys = [];
		EasyCopyTemplate.forEach(templates, function(template) {
			var key = document.createElement("key");
			key.setAttribute("id", "easycopy-key-" + template.id);
			key.setAttribute("label", "Copy " + template.name + " (EasyCopy)");
			key.easyCopyTemplate = template;
			//oncommand seems to be the only option that works. addEventListener didn't work with command. Taken from how Keyconfig does it.
			key.setAttribute("oncommand", "EasyCopy.copyTemplate(this.easyCopyTemplate);");

			var defaultKey = EasyCopy.defaultKeys[template.id];
			if (defaultKey) {
				key.setAttribute("modifiers", defaultKey.modifiers);
				key.setAttribute("key", defaultKey.key);
			} else {
				key.setAttribute("modifiers", "");
				key.setAttribute("key", "");
			}
			
			keys.push(key);
		});
		
		return keys;
	},
	
	loadKeys : function() {
		var keys = EasyCopyKeyManager.buildKeys(EasyCopy.templates);
		var keyset = document.getElementById("mainKeyset");
		for (var i = 0; i < keys.length; i++) {
			keyset.appendChild(keys[i]);
		}
	},
	
	clearKeys : function() {
		var keys = document.getElementsByTagName("keyset")[0].children;
	    var i = keys.length;

		while(i--) {
		    var key = keys[i];

		    if (key.getAttribute("id").indexOf("easycopy-key-") == 0) {
		    	key.parentNode.removeChild(key);
		    }
		}
	}
};