function EasyCopyTemplate() {
	this.id = null;
	this.template = null;
	this.name = null;
	this.type = EasyCopyTemplate.TEXT_TYPE;
	this.formatter = EasyCopyTemplate.NO_FORMATTER;
	this.order = -1;
	this.enabled = true;
	this.showInMainMenu = false;

	/**
	 * Iterates through all templates, calling <code>action</code> for every <b>enabled</b> template only.
	 */
	EasyCopyTemplate.forEach = function(templates, action) {
		for (var i = 0; i < templates.length; i++) {
			var template = templates[i];
			if (template.enabled) {
				action(template);
			}
		}
	};
	
	EasyCopyTemplate.defaultTemplate = function() {
		var template = new EasyCopyTemplate();
		template.id = new Date().getTime();
		template.name = "Untitled";
		template.template = "Enter template here";

		return template;
	};
};

EasyCopyTemplate.TEXT_TYPE = "text";
EasyCopyTemplate.HTML_TYPE = "html";

EasyCopyTemplate.NO_FORMATTER = "none";
EasyCopyTemplate.HTML_FORMATTER = "html";
