function EasyCopyVariableResolver() {
	EasyCopyVariableResolver.prototype.resolve = function(match, theDocument) {
		return match;
	};
	
	EasyCopyVariableResolver.prototype.appliesToContext = function(theDocument) {
		return true;
	};
};

//EasyCopyTitleVariableResolver
EasyCopyTitleVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyTitleVariableResolver() {
	EasyCopyTitleVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.contextualTitle(theDocument);
	};

};

//EasyCopyPageTitleVariableResolver
EasyCopyPageTitleVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyPageTitleVariableResolver() {
	EasyCopyPageTitleVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.getTitle(theDocument);
	};
};

//EasyCopyPageUrlVariableResolver
EasyCopyPageUrlVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyPageUrlVariableResolver() {
	EasyCopyPageUrlVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.getUrl(theDocument);
	};
};

//EasyCopyUrlVariableResolver
EasyCopyUrlVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyUrlVariableResolver() {
	EasyCopyUrlVariableResolver.prototype.resolve = function(match, theDocument) {
		if (EasyCopyBrowserDetails.onLink(theDocument)) {
			return EasyCopyBrowserDetails.getLinkUrl(theDocument);
		}
		
		return EasyCopyBrowserDetails.getUrl(theDocument);
	};
};

//EasyCopySelectionVariableResolver
EasyCopySelectionVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopySelectionVariableResolver() {
	EasyCopySelectionVariableResolver.prototype.appliesToContext = function(theDocument) {
		return EasyCopyBrowserDetails.contentIsSelected(theDocument);
	};

	EasyCopySelectionVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.getSelection(theDocument);
	};
};

//EasyCopyLinkTextVariableResolver
EasyCopyLinkTextVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyLinkTextVariableResolver() {
	EasyCopyLinkTextVariableResolver.prototype.appliesToContext = function(theDocument) {
		return EasyCopyBrowserDetails.onLink(theDocument);
	};

	EasyCopyLinkTextVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.getLinkText(theDocument);
	};
};

//EasyCopyLinkUrlVariableResolver
EasyCopyLinkUrlVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyLinkUrlVariableResolver() {
	EasyCopyLinkUrlVariableResolver.prototype.appliesToContext = function(theDocument) {
		return EasyCopyBrowserDetails.onLink(theDocument);
	};

	EasyCopyLinkUrlVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.getLinkUrl(theDocument);
	};
};

//EasyCopyTodayDateVariableResolver
EasyCopyTodayDateVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyTodayDateVariableResolver() {
	EasyCopyTodayDateVariableResolver.prototype.resolve = function(match, theDocument) {
		return new Date().toLocaleDateString();
	};
};

//EasyCopyTodayTimeVariableResolver
EasyCopyTodayTimeVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyTodayTimeVariableResolver() {
	EasyCopyTodayTimeVariableResolver.prototype.resolve = function(match, theDocument) {
		return new Date().toLocaleTimeString();
	};
};

//EasyCopyTodayDateTimeVariableResolver
EasyCopyTodayDateTimeVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyTodayDateTimeVariableResolver() {
	EasyCopyTodayDateTimeVariableResolver.prototype.resolve = function(match, theDocument) {
		return new Date().toLocaleString();
	};
};

//EasyCopyHtmlSourceVariableResolver
EasyCopyHtmlSourceVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyHtmlSourceVariableResolver() {
	EasyCopyHtmlSourceVariableResolver.prototype.resolve = function(match, theDocument) {
		if (EasyCopyBrowserDetails.contentIsSelected(theDocument)) {
			return EasyCopyBrowserDetails.getSelectedHtmlSource(theDocument);
		}

		return EasyCopyBrowserDetails.getDocumentHtmlSource(theDocument);
	};
};

//EasyCopyPromptVariableResolver
EasyCopyPromptVariableResolver.prototype = new EasyCopyVariableResolver();
function EasyCopyPromptVariableResolver() {
	EasyCopyPromptVariableResolver.prototype.resolve = function(match, theDocument) {
		return EasyCopyBrowserDetails.userPrompt(theDocument);
	};
};